"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.logInitHelp = exports.logBuildHelp = exports.logDefaultHelp = void 0;

var _logger = require("../lib/utils/logger");

var logDefaultHelp = function logDefaultHelp(cmds) {
  (0, _logger.printAndExit)("\n    Usage:\n      $ duck <command>\n    Available commands:\n      ".concat(cmds.join(", "), "\n    For more information run a command with the --help flag\n      $ duck <command> --help\n  "));
};

exports.logDefaultHelp = logDefaultHelp;

var logBuildHelp = function logBuildHelp() {
  (0, _logger.printAndExit)("\n    Build the duck project in the current directory.\n\n    Usage:\n      $ duck build\n\n    duck build --help   display help\n    duck build --path   set the path to build from\n    duck build --proof  include proof lines\n    duck build --watch  rebuild on file changes\n  ");
};

exports.logBuildHelp = logBuildHelp;

var logInitHelp = function logInitHelp() {
  (0, _logger.printAndExit)("\n    Initialize a new duck project in the current directory.\n\n    Usage:\n      $ duck init\n  ");
};

exports.logInitHelp = logInitHelp;