"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.build = void 0;

var _config = require("./config");

var _data = require("./data");

var _template = require("./template");

var _format = require("./format");

var _logger = require("./utils/logger");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var build =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(projectRoot) {
    var config, data, renderings;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            (0, _logger.verboseLog)("...Building deck for ".concat(projectRoot));
            _context.next = 3;
            return (0, _config.readConfig)(projectRoot);

          case 3:
            config = _context.sent;
            _context.next = 6;
            return (0, _data.readData)(projectRoot, config);

          case 6:
            data = _context.sent;
            _context.next = 9;
            return (0, _template.renderTemplates)(projectRoot, config, data);

          case 9:
            renderings = _context.sent;
            _context.next = 12;
            return (0, _format.formatCards)(projectRoot, config, data, renderings);

          case 12:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function build(_x) {
    return _ref.apply(this, arguments);
  };
}();

exports.build = build;