"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.readConfig = void 0;

var _fsp = _interopRequireDefault(require("./utils/fsp"));

var _path = _interopRequireDefault(require("path"));

var _jsYaml = _interopRequireDefault(require("js-yaml"));

var _logger = require("./utils/logger");

var _constants = require("./constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var readConfig =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(projectRoot) {
    var configFile, rawConfig;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            configFile = _path.default.join(projectRoot, _constants.CONF_FILE);
            (0, _logger.verboseLog)("...Looking for config in file ".concat(configFile));
            _context.prev = 2;
            _context.t0 = _jsYaml.default;
            _context.next = 6;
            return _fsp.default.readFile(configFile, "utf8");

          case 6:
            _context.t1 = _context.sent;
            rawConfig = _context.t0.safeLoad.call(_context.t0, _context.t1);
            processConfig(rawConfig);
            return _context.abrupt("return", rawConfig);

          case 12:
            _context.prev = 12;
            _context.t2 = _context["catch"](2);
            console.error("...an error while reading the config: ", _context.t2);
            throw _context.t2;

          case 16:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this, [[2, 12]]);
  }));

  return function readConfig(_x) {
    return _ref.apply(this, arguments);
  };
}();

exports.readConfig = readConfig;

var processConfig = function processConfig(config) {
  for (var key in config) {
    processDeckConfig(config[key], key);
  }
};

var processDeckConfig = function processDeckConfig(deckConfig, deckKey) {
  if (!deckConfig.width) {
    throw "Parameter 'width' is required in deck ".concat(deckKey);
  }

  if (!deckConfig.height) {
    throw "Parameter 'height' is required in deck ".concat(deckKey);
  }

  deckConfig.format = normalizeFormat(deckConfig.format || "svg");
  deckConfig.data = deckConfig.data || "".concat(deckKey, ".csv");
  deckConfig.templateFront = deckConfig.templateFront || "".concat(deckKey, ".js");
};

var normalizeFormat = function normalizeFormat(format) {
  if (Array.isArray(format)) {
    return format;
  }

  return [format];
};