"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cropStream = void 0;

var _jimp = _interopRequireDefault(require("jimp"));

var _mississippi = _interopRequireDefault(require("mississippi"));

var _progressBar = require("../utils/progressBar");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var cropStream = function cropStream(_ref) {
  var config = _ref.config,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 0 : _ref$size;
  var pngBuffers = [];
  var cropBar = (0, _progressBar.progressBar)("Crop", size);
  var bleed = config.pdf.bleed,
      width = config.width,
      height = config.height;
  return _mississippi.default.through.obj(
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(chunk, enc, cb) {
      var cardWidthPx, cardHeightPx, croppedBuffer;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!bleed) {
                _context.next = 9;
                break;
              }

              cardWidthPx = width - bleed * 2;
              cardHeightPx = height - bleed * 2;
              _context.next = 5;
              return _jimp.default.read(chunk).then(function (img) {
                cropBar.tick();
                return img.crop(bleed, bleed, cardWidthPx, cardHeightPx).getBufferAsync(_jimp.default.MIME_PNG);
              });

            case 5:
              croppedBuffer = _context.sent;
              pngBuffers.push(croppedBuffer);
              _context.next = 10;
              break;

            case 9:
              pngBuffers.push(chunk);

            case 10:
              cb(null, null);

            case 11:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function (_x, _x2, _x3) {
      return _ref2.apply(this, arguments);
    };
  }(), function (cb) {
    cb(null, pngBuffers);
  });
};

exports.cropStream = cropStream;