"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pngStream = void 0;

var _mississippi = _interopRequireDefault(require("mississippi"));

var _formatPng = require("../formatters/formatPng");

var _filenames = require("../utils/filenames");

var _fsp = _interopRequireDefault(require("../utils/fsp"));

var _progressBar = require("../utils/progressBar");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var pngStream = function pngStream(_ref) {
  var output = _ref.output,
      converter = _ref.converter,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 0 : _ref$size;
  var pngBar = (0, _progressBar.progressBar)("PNG", size);
  var pngIndex = 0;
  return _mississippi.default.through.obj(
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(chunk, enc, cb) {
      var pngBuffer;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return (0, _formatPng.formatPng)(converter, chunk);

            case 2:
              pngBuffer = _context.sent;
              _context.next = 5;
              return _fsp.default.writeFile((0, _filenames.pngname)(pngIndex, output), pngBuffer).then(pngBar.tick());

            case 5:
              pngIndex++;
              cb(null, pngBuffer);

            case 7:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function (_x, _x2, _x3) {
      return _ref2.apply(this, arguments);
    };
  }());
};

exports.pngStream = pngStream;