"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.svgStream = void 0;

var _mississippi = _interopRequireDefault(require("mississippi"));

var _progressBar = require("../utils/progressBar");

var _formatSvg = require("../formatters/formatSvg");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var svgStream = function svgStream(_ref) {
  var output = _ref.output,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 0 : _ref$size;
  var svgIndex = 0;
  var svgBar = (0, _progressBar.progressBar)("SVG", size);
  return _mississippi.default.through.obj(
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(chunk, enc, cb) {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return (0, _formatSvg.formatSvg)(chunk, svgIndex, output).then(function () {
                return svgBar.tick();
              });

            case 2:
              svgIndex++;
              cb(null, chunk);

            case 4:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function (_x, _x2, _x3) {
      return _ref2.apply(this, arguments);
    };
  }());
};

exports.svgStream = svgStream;