"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _fs = _interopRequireWildcard(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _mkdirp = _interopRequireDefault(require("mkdirp"));

var _util = require("util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

var readJson = function readJson(p, cb) {
  _fs.default.readFile(_path.default.resolve(p), function (err, data) {
    if (err) cb(err);else cb(null, JSON.parse(data));
  });
};

var writeWithDirs = function writeWithDirs(dest, content, cb) {
  var destDir = _path.default.dirname(dest);

  if (!_fs.default.existsSync(destDir)) {
    _mkdirp.default.sync(destDir);
  }

  _fs.default.writeFile(dest, content, cb);
};

var _default = {
  mkdirp: (0, _util.promisify)(_mkdirp.default),
  readJson: (0, _util.promisify)(readJson),
  exists: (0, _util.promisify)(_fs.default.exists),
  mkdir: (0, _util.promisify)(_fs.default.mkdir),
  writeFile: (0, _util.promisify)(_fs.default.writeFile),
  writeWithDirs: (0, _util.promisify)(writeWithDirs),
  readFile: (0, _util.promisify)(_fs.default.readFile),
  unlink: (0, _util.promisify)(_fs.default.unlink),
  rmdir: (0, _util.promisify)(_fs.default.rmdir)
};
exports.default = _default;