"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.transform = exports.transformDir = void 0;

var _fs = _interopRequireDefault(require("fs"));

var _fsp = _interopRequireDefault(require("./fsp"));

var _core = require("@babel/core");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var globby = require("globby");

var path = require("path");

var transformDir =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(src, dest, options) {
    var t;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            src = path.resolve(src);
            dest = path.resolve(dest);
            _context.next = 4;
            return _fsp.default.exists(dest);

          case 4:
            if (_context.sent) {
              _context.next = 7;
              break;
            }

            _context.next = 7;
            return _fsp.default.mkdir(dest);

          case 7:
            t = function t(file) {
              return transform(file, src, dest, _objectSpread({
                filename: file
              }, options));
            };

            return _context.abrupt("return", globby("**/*.js", {
              cwd: src
            }).then(function (files) {
              return Promise.all(files.map(t));
            }));

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function transformDir(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

exports.transformDir = transformDir;

var transform =
/*#__PURE__*/
function () {
  var _ref2 = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2(file, src, dest) {
    var _ref3,
        babel,
        onFile,
        filePath,
        destPath,
        _ref4,
        code,
        _args2 = arguments;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _ref3 = _args2.length > 3 && _args2[3] !== undefined ? _args2[3] : {}, babel = _ref3.babel, onFile = _ref3.onFile;
            filePath = path.join(src, file);
            destPath = path.join(dest, file);
            _context2.next = 5;
            return (0, _core.transformFileAsync)(filePath, babel);

          case 5:
            _ref4 = _context2.sent;
            code = _ref4.code;
            return _context2.abrupt("return", _fsp.default.writeWithDirs(destPath, code).then(function () {
              onFile && onFile(file);
            }));

          case 8:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function transform(_x4, _x5, _x6) {
    return _ref2.apply(this, arguments);
  };
}();

exports.transform = transform;