"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Card = void 0;

var _react = _interopRequireDefault(require("react"));

var _CutArea = require("./CutArea");

var _DeckContext = require("./DeckContext");

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var BaseCard = function BaseCard(_ref) {
  var _ref$safeZone = _ref.safeZone,
      safeZone = _ref$safeZone === void 0 ? true : _ref$safeZone,
      _ref$cut = _ref.cut,
      cut = _ref$cut === void 0 ? true : _ref$cut,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ["safeZone", "cut", "children"]);

  var width = props.width,
      height = props.height,
      _props$cutMargin = props.cutMargin,
      cutMargin = _props$cutMargin === void 0 ? 37.5 : _props$cutMargin,
      _props$safeMargin = props.safeMargin,
      safeMargin = _props$safeMargin === void 0 ? 75 : _props$safeMargin,
      _props$cutColor = props.cutColor,
      cutColor = _props$cutColor === void 0 ? "red" : _props$cutColor,
      _props$safeColor = props.safeColor,
      safeColor = _props$safeColor === void 0 ? "blue" : _props$safeColor;

  var CardBackground = _react.default.createElement("rect", _extends({
    id: "background",
    x: "0",
    y: "0",
    width: width,
    height: height,
    strokeWidth: "0",
    fill: "none"
  }, props));

  var CutZone = _react.default.createElement(_CutArea.CutArea, {
    id: "cut",
    margin: cutMargin,
    width: width,
    height: height,
    color: cutColor,
    strokeDasharray: null
  });

  var SafeZone = _react.default.createElement(_CutArea.CutArea, {
    id: "safe_zone",
    margin: safeMargin,
    width: width,
    height: height,
    color: safeColor,
    strokeDasharray: "3 3"
  });

  return _react.default.createElement("g", null, _react.default.createElement("defs", null, _react.default.createElement("clipPath", {
    id: "card"
  }, CardBackground), _react.default.createElement("clipPath", {
    id: "cut"
  }, CutZone), _react.default.createElement("clipPath", {
    id: "safe"
  }, SafeZone)), CardBackground, process.env.PROOF && cut && CutZone, process.env.PROOF && safeZone && SafeZone, children);
};

var Card = function Card(props) {
  return _react.default.createElement(_DeckContext.DeckConsumer, null, function (context) {
    var newProps = _objectSpread({
      width: context.width,
      height: context.height
    }, props);

    return _react.default.createElement(BaseCard, newProps);
  });
};

exports.Card = Card;
var cardPropTypes = {
  width: _propTypes.default.number,
  height: _propTypes.default.number,
  cutMargin: _propTypes.default.number,
  safeMargin: _propTypes.default.number,
  cutColor: _propTypes.default.string,
  safeColor: _propTypes.default.string
};
BaseCard.propTypes = cardPropTypes;
Card.propTypes = cardPropTypes;