"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CutArea = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _propTypes2 = require("../lib/propTypes");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var CutArea = function CutArea(_ref) {
  var _ref$radius = _ref.radius,
      radius = _ref$radius === void 0 ? 37.5 : _ref$radius,
      _ref$margin = _ref.margin,
      margin = _ref$margin === void 0 ? 37.5 : _ref$margin,
      _ref$width = _ref.width,
      width = _ref$width === void 0 ? 850 : _ref$width,
      _ref$height = _ref.height,
      height = _ref$height === void 0 ? 1125 : _ref$height,
      _ref$color = _ref.color,
      color = _ref$color === void 0 ? "red" : _ref$color,
      _ref$strokeDasharray = _ref.strokeDasharray,
      strokeDasharray = _ref$strokeDasharray === void 0 ? "3 3" : _ref$strokeDasharray,
      props = _objectWithoutProperties(_ref, ["radius", "margin", "width", "height", "color", "strokeDasharray"]);

  return _react.default.createElement("rect", _extends({
    x: margin,
    y: margin,
    rx: radius,
    ry: radius,
    width: width - margin * 2,
    height: height - margin * 2,
    strokeWidth: "2",
    stroke: color,
    fill: "none",
    strokeDasharray: strokeDasharray
  }, props));
};

exports.CutArea = CutArea;
CutArea.propTypes = _objectSpread({}, _propTypes2.svgPropTypes, {
  radius: _propTypes.default.number,
  color: _propTypes.default.string,
  strokeDasharray: _propTypes.default.string
});