"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Text = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _propTypes2 = require("../lib/propTypes");

var _lodash = _interopRequireDefault(require("lodash"));

var _measuretext = require("../lib/measuretext");

var _splittext = require("../lib/splittext");

var _downvg = require("../lib/downvg");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Text = function Text(_ref) {
  var _ref$lineHeight = _ref.lineHeight,
      lineHeight = _ref$lineHeight === void 0 ? "22px" : _ref$lineHeight,
      _ref$fontSize = _ref.fontSize,
      fontSize = _ref$fontSize === void 0 ? "12px" : _ref$fontSize,
      _ref$fontFamily = _ref.fontFamily,
      fontFamily = _ref$fontFamily === void 0 ? "Helvetica" : _ref$fontFamily,
      _ref$fontStyle = _ref.fontStyle,
      fontStyle = _ref$fontStyle === void 0 ? "regular" : _ref$fontStyle,
      _ref$baseline = _ref.baseline,
      baseline = _ref$baseline === void 0 ? "hanging" : _ref$baseline,
      children = _ref.children,
      color = _ref.color,
      x = _ref.x,
      y = _ref.y,
      props = _objectWithoutProperties(_ref, ["lineHeight", "fontSize", "fontFamily", "fontStyle", "baseline", "children", "color", "x", "y"]);

  var lines = (0, _splittext.splitText)(children, props.width, {
    fontFamily: fontFamily,
    fontSize: fontSize,
    lineHeight: lineHeight
  });
  var lineSize = (0, _measuretext.measureText)({
    text: lines[0],
    fontFamily: fontFamily,
    fontSize: fontSize,
    lineHeight: lineHeight
  });

  var spans = _lodash.default.map(lines, function (l, i) {
    return _react.default.createElement("tspan", {
      x: x,
      y: i > 0 ? lineHeight : undefined,
      key: i,
      width: lineSize.width.value,
      height: lineSize.height.value,
      dangerouslySetInnerHTML: {
        __html: (0, _downvg.downvg)(l)
      },
      dominantBaseline: "no-change"
    });
  });

  return _react.default.createElement(_react.default.Fragment, null, children && _react.default.createElement("text", _extends({
    dominantBaseline: baseline,
    fontFamily: fontFamily,
    fontSize: fontSize,
    fontStyle: fontStyle,
    fill: color,
    y: y,
    width: lineSize.width.value,
    height: lineSize.height.value * lines.length
  }, props), spans));
};

exports.Text = Text;
Text.propTypes = _objectSpread({}, _propTypes2.svgPropTypes, {
  fontSize: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  lineHeight: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  fontFamily: _propTypes.default.string,
  fontStyle: _propTypes.default.oneOf(["regular", "italic"]),
  baseline: _propTypes.default.oneOf(["hanging"]),
  fill: _propTypes.default.string
});