"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.svgPropTypes = exports.flexboxPropTypes = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var flexboxPropTypes = {
  alignContent: _propTypes.default.oneOf(["center", "flex-end", "flex-start", "space-around", "space-between", "stretch"]),
  alignItems: _propTypes.default.oneOf(["baseline", "center", "flex-end", "flex-start", "stretch"]),
  alignSelf: _propTypes.default.oneOf(["baseline", "center", "flex-end", "flex-start", "stretch"]),
  children: _propTypes.default.node,
  display: _propTypes.default.oneOf(["flex", "inline-flex"]),
  element: _propTypes.default.oneOf(["article", "aside", "div", "figure", "footer", "header", "main", "nav", "section"]),
  flex: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  flexBasis: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  flexDirection: _propTypes.default.oneOf(["column-reverse", "column", "row-reverse", "row"]),
  flexGrow: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  flexShrink: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  flexWrap: _propTypes.default.oneOf(["nowrap", "wrap-reverse", "wrap"]),
  height: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  inline: _propTypes.default.bool,
  justifyContent: _propTypes.default.oneOf(["center", "flex-end", "flex-start", "space-around", "space-between"]),
  margin: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  marginBottom: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  marginLeft: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  marginRight: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  marginTop: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  maxHeight: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  maxWidth: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  minHeight: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  minWidth: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  order: _propTypes.default.number,
  padding: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  paddingBottom: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  paddingLeft: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  paddingRight: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  paddingTop: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  style: _propTypes.default.object,
  width: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number])
};
exports.flexboxPropTypes = flexboxPropTypes;
var svgPropTypes = {
  x: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  y: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  width: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  height: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  viewBox: _propTypes.default.string
};
exports.svgPropTypes = svgPropTypes;