"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getDisplay = exports.getEdge = exports.getFlexWrap = exports.getFlexDirection = exports.getAlign = exports.getJustifyContent = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _yogaLayout = _interopRequireDefault(require("yoga-layout"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getJustifyContent = function getJustifyContent(val) {
  var opts = {
    center: _yogaLayout.default.JUSTIFY_CENTER,
    "flex-end": _yogaLayout.default.JUSTIFY_FLEX_END,
    "flex-start": _yogaLayout.default.JUSTIFY_FLEX_START,
    "space-around": _yogaLayout.default.JUSTIFY_SPACE_AROUND,
    "space-between": _yogaLayout.default.JUSTIFY_SPACE_BETWEEN,
    "space-evenly": _yogaLayout.default.JUSTIFY_SPACE_EVENLY
  };
  return _lodash.default.get(opts, val, _yogaLayout.default.JUSTIFY_FLEX_START);
};

exports.getJustifyContent = getJustifyContent;

var getAlign = function getAlign(val) {
  var opts = {
    auto: _yogaLayout.default.ALIGN_AUTO,
    baseline: _yogaLayout.default.ALIGN_BASELINE,
    center: _yogaLayout.default.ALIGN_CENTER,
    "flex-end": _yogaLayout.default.ALIGN_FLEX_END,
    "flex-start": _yogaLayout.default.ALIGN_FLEX_START,
    "space-around": _yogaLayout.default.ALIGN_SPACE_AROUND,
    "space-between": _yogaLayout.default.ALIGN_SPACE_BETWEEN,
    stretch: _yogaLayout.default.ALIGN_STRETCH
  };
  return _lodash.default.get(opts, val, _yogaLayout.default.ALIGN_FLEX_START);
};

exports.getAlign = getAlign;

var getFlexDirection = function getFlexDirection(val) {
  var opts = {
    column: _yogaLayout.default.FLEX_DIRECTION_COLUMN,
    "column-reverse": _yogaLayout.default.FLEX_DIRECTION_COLUMN_REVERSE,
    count: _yogaLayout.default.FLEX_DIRECTION_COUNT,
    row: _yogaLayout.default.FLEX_DIRECTION_ROW,
    "row-reverse": _yogaLayout.default.FLEX_DIRECTION_ROW_REVERSE
  };
  return _lodash.default.get(opts, val, _yogaLayout.default.FLEX_DIRECTION_ROW);
};

exports.getFlexDirection = getFlexDirection;

var getDirection = function getDirection(val) {
  var opts = {
    inherit: _yogaLayout.default.DIRECTION_INHERIT,
    ltr: _yogaLayout.default.DIRECTION_LTR,
    rtl: _yogaLayout.default.DIRECTION_RTL
  };
  return _lodash.default.get(opts, val, _yogaLayout.default.DIRECTION_INHERIT);
};

var getFlexWrap = function getFlexWrap(val) {
  var opts = {
    "no-wrap": _yogaLayout.default.WRAP_NO_WRAP,
    wrap: _yogaLayout.default.WRAP_WRAP,
    "wrap-reverse": _yogaLayout.default.WRAP_WRAP_REVERSE
  };
  return _lodash.default.get(opts, val, _yogaLayout.default.WRAP_WRAP);
};

exports.getFlexWrap = getFlexWrap;

var getEdge = function getEdge(val) {
  var opts = {
    left: _yogaLayout.default.EDGE_LEFT,
    top: _yogaLayout.default.EDGE_TOP,
    right: _yogaLayout.default.EDGE_RIGHT,
    bottom: _yogaLayout.default.EDGE_BOTTOM,
    start: _yogaLayout.default.EDGE_START,
    end: _yogaLayout.default.EDGE_END,
    horizontal: _yogaLayout.default.EDGE_HORIZONTAL,
    vertical: _yogaLayout.default.EDGE_VERTICAL,
    all: _yogaLayout.default.EDGE_ALL
  };
  return _lodash.default.get(opts, val, _yogaLayout.default.EDGE_ALL);
};

exports.getEdge = getEdge;

var getDisplay = function getDisplay(val) {
  var opts = {
    flex: _yogaLayout.default.DISPLAY_FLEX,
    none: _yogaLayout.default.DISPLAY_NONE
  };
  return _lodash.default.get(opts, val, _yogaLayout.default.DISPLAY_FLEX);
};

exports.getDisplay = getDisplay;

var getUnit = function getUnit(val) {
  var opts = {
    auto: _yogaLayout.default.UNIT_AUTO,
    percent: _yogaLayout.default.UNIT_PERCENT,
    point: _yogaLayout.default.UNIT_POINT,
    undefined: _yogaLayout.default.UNIT_UNDEFINED
  };
  return opts[val];
};

var getOverflow = function getOverflow(val) {
  var opts = {
    hidden: _yogaLayout.default.OVERFLOW_HIDDEN,
    scroll: _yogaLayout.default.OVERFLOW_SCROLL,
    visible: _yogaLayout.default.OVERFLOW_VISIBLE
  };
  return opts[val];
};

var getPositionType = function getPositionType(val) {
  var opts = {
    absolute: _yogaLayout.default.POSITION_TYPE_ABSOLUTE,
    relative: _yogaLayout.default.POSITION_TYPE_RELATIVE
  };
  return opts[val];
};